
    create table cm_admin (
        cm_id number(19,0) not null,
        cm_built_in number(1,0),
        cm_enabled number(1,0),
        cm_password varchar2(255 char),
        cm_password_encoding number(10,0),
        cm_salt varchar2(255 char),
        cm_username varchar2(255 char) not null unique,
        primary key (cm_id)
    );

    create table cm_admin_cm_authorities (
        cm_admin number(19,0) not null,
        cm_authorities number(19,0) not null,
        primary key (cm_admin, cm_authorities)
    );

    create table cm_authority (
        cm_id number(19,0) not null,
        cm_role varchar2(255 char) not null unique,
        primary key (cm_id)
    );

    create table cm_blob (
        cm_id number(19,0) not null,
        cm_blob blob,
        primary key (cm_id)
    );

    create table cm_certificate_request (
        cm_id number(19,0) not null,
        cm_certificate_handler_name varchar2(255 char),
        cm_created timestamp not null,
        cm_crl_dist_point varchar2(1024 char),
        cm_data blob,
        cm_email varchar2(320 char),
        cm_info varchar2(1024 char),
        cm_iteration number(10,0),
        cm_key_length number(10,0),
        cm_last_message varchar2(1024 char),
        cm_last_updated timestamp,
        cm_next_update timestamp,
        cm_private_key blob,
        cm_public_key blob,
        cm_signature_algorithm varchar2(255 char),
        cm_subject blob,
        cm_validity number(10,0),
        primary key (cm_id)
    );

    create table cm_certificates (
        cm_id number(19,0) not null,
        cm_not_before timestamp,
        cm_not_after timestamp,
        cm_issuer varchar2(4000),
        cm_issuer_friendly varchar2(4000),
        cm_serial varchar2(1024 char),
        cm_subject_key_identifier varchar2(4000),
        cm_subject varchar2(4000),
        cm_subject_friendly varchar2(4000),
        cm_certificate blob,
        cm_thumbprint varchar2(255 char),
        cm_cert_path blob,
        cm_cert_path_type varchar2(255 char),
        cm_creation_date timestamp,
        cm_date_path_updated timestamp,
        cm_key_alias varchar2(1024 char),
        cm_store_name varchar2(255 char),
        primary key (cm_id),
        unique (cm_store_name, cm_thumbprint)
    );

    create table cm_certificates_email (
        cm_certificates_id number(19,0) not null,
        cm_email varchar2(320 char)
    );

    create table cm_crls (
        cm_id number(19,0) not null,
        cm_creation_date timestamp,
        cm_issuer varchar2(4000),
        cm_next_update timestamp,
        cm_this_update timestamp,
        cm_crl_number varchar2(1024 char),
        cm_crl blob,
        cm_thumbprint varchar2(255 char),
        cm_store_name varchar2(255 char),
        primary key (cm_id),
        unique (cm_store_name, cm_thumbprint)
    );

    create table cm_ctl (
        cm_id number(19,0) not null,
        cm_name varchar2(255 char),
        cm_thumbprint varchar2(255 char) not null,
        primary key (cm_id),
        unique (cm_name, cm_thumbprint)
    );

    create table cm_ctl_cm_name_values (
        cm_ctl number(19,0) not null,
        cm_value clob,
        cm_name varchar2(255 char),
        primary key (cm_ctl, cm_name)
    );

    create table cm_keyring (
        cm_id number(19,0) not null,
        cm_content blob,
        cm_content_type varchar2(255),
        cm_creation_date timestamp,
        cm_public_key blob not null,
        cm_expiration_date timestamp,
        cm_fingerprint varchar2(256 char) not null,
        cm_insertion_date timestamp,
        cm_keyid number(19,0) not null,
        cm_keyidhex varchar2(255 char) not null,
        cm_key_ring_name varchar2(256 char) not null,
        cm_master number(1,0) not null,
        cm_parent_keyid number(19,0),
        cm_private_key_alias varchar2(256 char),
        cm_sha256fingerprint varchar2(256 char) not null,
        cm_parentid number(19,0),
        primary key (cm_id),
        unique (cm_key_ring_name, cm_sha256fingerprint)
    );

    create table cm_keyring_email (
        cm_keyring_id number(19,0) not null,
        cm_email varchar2(320 char)
    );

    create table cm_keyring_userid (
        cm_keyring_id number(19,0) not null,
        cm_userid varchar2(320 char)
    );

    create table cm_keystore (
        cm_id number(19,0) not null,
        cm_alias varchar2(1024 char) not null,
        cm_certificate blob,
        cm_certificate_type varchar2(255 char),
        cm_thumbprint varchar2(255 char),
        cm_certificate_chain blob,
        cm_creation_date timestamp,
        cm_encoded_key blob,
        cm_store_name varchar2(255 char) not null,
        primary key (cm_id),
        unique (cm_store_name, cm_alias)
    );

    create table cm_mail_repository (
        cm_id varchar2(255 char) not null,
        cm_data blob,
        cm_created timestamp,
        cm_from_header varchar2(1024 char),
        cm_last_updated timestamp,
        cm_messageid varchar2(1024 char),
        cm_originator varchar2(1024 char),
        cm_remote_address varchar2(1024 char),
        cm_repository varchar2(255 char),
        cm_sender varchar2(1024 char),
        cm_subject varchar2(1024 char),
        cm_mime number(19,0),
        primary key (cm_id)
    );

    create table cm_mail_repository_recipients (
        cm_id varchar2(255 char) not null,
        cm_recipients varchar2(1024 char)
    );

    create table cm_named_blob (
        cm_id number(19,0) not null,
        cm_category varchar2(255 char) not null,
        cm_name varchar2(255 char) not null,
        cm_blob_entity number(19,0),
        primary key (cm_id),
        unique (cm_category, cm_name)
    );

    create table cm_named_blob_cm_named_blobs (
        cm_named_blob number(19,0) not null,
        cm_named_blobs number(19,0) not null,
        primary key (cm_named_blob, cm_named_blobs)
    );

    create table cm_pgp_trust_list (
        cm_id number(19,0) not null,
        cm_fingerprint varchar2(255 char) not null,
        cm_name varchar2(255 char),
        primary key (cm_id),
        unique (cm_name, cm_fingerprint)
    );

    create table cm_pgp_trust_list_cm_name_valu (
        cm_pgp_trust_list number(19,0) not null,
        cm_value clob,
        cm_name varchar2(255 char),
        primary key (cm_pgp_trust_list, cm_name)
    );

    create table cm_properties (
        cm_id number(19,0) not null,
        cm_category varchar2(320 char) unique,
        primary key (cm_id)
    );

    create table cm_properties_cm_name_values (
        cm_properties number(19,0) not null,
        cm_value clob,
        cm_name varchar2(255 char),
        primary key (cm_properties, cm_name)
    );

    create table cm_sms (
        cm_id number(19,0) not null,
        cm_data blob,
        cm_date_created timestamp,
        cm_date_last_try timestamp,
        cm_last_error varchar2(1024 char),
        cm_message varchar2(2048 char) not null,
        cm_phone_number varchar2(255 char) not null,
        primary key (cm_id)
    );

    create table cm_userpreferences (
        cm_id number(19,0) not null,
        cm_category varchar2(320 char) not null,
        cm_name varchar2(320 char) not null,
        cm_key_and_certificate_entry number(19,0),
        cm_property_entity number(19,0),
        primary key (cm_id),
        unique (cm_category, cm_name)
    );

    create table cm_userpreferences_cm_certific (
        cm_userpreferences number(19,0) not null,
        cm_certificates number(19,0) not null,
        primary key (cm_userpreferences, cm_certificates)
    );

    create table cm_userpreferences_cm_named_bl (
        cm_userpreferences number(19,0) not null,
        cm_named_blobs number(19,0) not null,
        primary key (cm_userpreferences, cm_named_blobs)
    );

    create table cm_userpreferences_inheritedpr (
        cm_userpreferences number(19,0) not null,
        cm_index number(19,0) not null,
        cm_inherited_preferences_id number(19,0) not null,
        primary key (cm_userpreferences, cm_index, cm_inherited_preferences_id)
    );

    create table cm_userpreferences_named_certi (
        cm_userpreferences number(19,0) not null,
        cm_certificate_entry number(19,0),
        cm_name varchar2(255 char)
    );

    create table cm_users (
        cm_id number(19,0) not null,
        cm_email varchar2(320 char) not null unique,
        cm_user_preferences_entity number(19,0),
        primary key (cm_id)
    );

    alter table cm_admin_cm_authorities 
        add constraint FKB92F86713CAF3373 
        foreign key (cm_admin) 
        references cm_admin;

    alter table cm_admin_cm_authorities 
        add constraint FKB92F867123233879 
        foreign key (cm_authorities) 
        references cm_authority;

    create index certificateRequest_email_index on cm_certificate_request (cm_email);

    create index cert_req_next_update_index on cm_certificate_request (cm_next_update);

    create index cert_req_created_index on cm_certificate_request (cm_created);

    create index certificates_issuer_index on cm_certificates (cm_issuer);

    create index certificates_key_alias_index on cm_certificates (cm_key_alias);

    create index certificates_thumbprint_index on cm_certificates (cm_thumbprint);

    create index cert_creationdate_index on cm_certificates (cm_creation_date);

    create index certificates_subject_index on cm_certificates (cm_subject);

    create index certificates_store_name_index on cm_certificates (cm_store_name);

    create index cert_subject_key_id_index on cm_certificates (cm_subject_key_identifier);

    create index certificates_serial_index on cm_certificates (cm_serial);

    alter table cm_certificates_email 
        add constraint FK618BE14E81712A2F 
        foreign key (cm_certificates_id) 
        references cm_certificates;

    create index crls_thumbprint_index on cm_crls (cm_thumbprint);

    create index crls_issuer_index on cm_crls (cm_issuer);

    create index crls_crlnumber_index on cm_crls (cm_crl_number);

    create index crls_store_name_index on cm_crls (cm_store_name);

    alter table cm_ctl_cm_name_values 
        add constraint FKBD85E99A2BE6F657 
        foreign key (cm_ctl) 
        references cm_ctl;

    alter table cm_keyring 
        add constraint FKF58C6A3A2B2B0656 
        foreign key (cm_parentid) 
        references cm_keyring;

    alter table cm_keyring_email 
        add constraint FK951D05577431C1C 
        foreign key (cm_keyring_id) 
        references cm_keyring;

    alter table cm_keyring_userid 
        add constraint FK2A27AFCB7431C1C 
        foreign key (cm_keyring_id) 
        references cm_keyring;

    create index keystore_alias_index on cm_keystore (cm_alias);

    create index keystore_storename_index on cm_keystore (cm_store_name);

    alter table cm_mail_repository 
        add constraint FKB12990FDFF89F4D6 
        foreign key (cm_mime) 
        references cm_blob;

    alter table cm_mail_repository_recipients 
        add constraint FKDEF805FC716095DA 
        foreign key (cm_id) 
        references cm_mail_repository;

    alter table cm_named_blob 
        add constraint FKB36CEFD8FD03645D 
        foreign key (cm_blob_entity) 
        references cm_blob;

    alter table cm_named_blob_cm_named_blobs 
        add constraint FK1AE7DEE2615369E4 
        foreign key (cm_named_blob) 
        references cm_named_blob;

    alter table cm_named_blob_cm_named_blobs 
        add constraint FK1AE7DEE2681785A7 
        foreign key (cm_named_blobs) 
        references cm_named_blob;

    alter table cm_pgp_trust_list_cm_name_valu 
        add constraint FKF10091B28CA8D07B 
        foreign key (cm_pgp_trust_list) 
        references cm_pgp_trust_list;

    alter table cm_properties_cm_name_values 
        add constraint FK9425A1F8BDF917CD 
        foreign key (cm_properties) 
        references cm_properties;

    create index sms_datelasttry_index on cm_sms (cm_date_last_try);

    create index userpreferences_name_index on cm_userpreferences (cm_name);

    create index userpreferences_category_index on cm_userpreferences (cm_category);

    alter table cm_userpreferences 
        add constraint FK9730847813954F5D 
        foreign key (cm_property_entity) 
        references cm_properties;

    alter table cm_userpreferences 
        add constraint FK97308478E01BB373 
        foreign key (cm_key_and_certificate_entry) 
        references cm_certificates;

    alter table cm_userpreferences_cm_certific 
        add constraint FKF8038A099FB1915C 
        foreign key (cm_userpreferences) 
        references cm_userpreferences;

    alter table cm_userpreferences_cm_certific 
        add constraint FKF8038A092BA6D0F7 
        foreign key (cm_certificates) 
        references cm_certificates;

    alter table cm_userpreferences_cm_named_bl 
        add constraint FK91B98DFE9FB1915C 
        foreign key (cm_userpreferences) 
        references cm_userpreferences;

    alter table cm_userpreferences_cm_named_bl 
        add constraint FK91B98DFE681785A7 
        foreign key (cm_named_blobs) 
        references cm_named_blob;

    alter table cm_userpreferences_inheritedpr 
        add constraint FK1026F9159FB1915C 
        foreign key (cm_userpreferences) 
        references cm_userpreferences;

    alter table cm_userpreferences_inheritedpr 
        add constraint FK1026F915F2EBE2E0 
        foreign key (cm_inherited_preferences_id) 
        references cm_userpreferences;

    alter table cm_userpreferences_named_certi 
        add constraint FK7FA2D4F89FB1915C 
        foreign key (cm_userpreferences) 
        references cm_userpreferences;

    alter table cm_userpreferences_named_certi 
        add constraint FK7FA2D4F87F50D4BB 
        foreign key (cm_certificate_entry) 
        references cm_certificates;

    alter table cm_users 
        add constraint FK5ADE85F35754340D 
        foreign key (cm_user_preferences_entity) 
        references cm_userpreferences;

    create sequence hibernate_sequence;
